# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = [
    'GetWorkspaceResult',
    'AwaitableGetWorkspaceResult',
    'get_workspace',
    'get_workspace_output',
]

@pulumi.output_type
class GetWorkspaceResult:
    """
    A collection of values returned by getWorkspace.
    """
    def __init__(__self__, default_data_collection_endpoint_id=None, default_data_collection_rule_id=None, id=None, location=None, name=None, public_network_access_enabled=None, query_endpoint=None, resource_group_name=None, tags=None):
        if default_data_collection_endpoint_id and not isinstance(default_data_collection_endpoint_id, str):
            raise TypeError("Expected argument 'default_data_collection_endpoint_id' to be a str")
        pulumi.set(__self__, "default_data_collection_endpoint_id", default_data_collection_endpoint_id)
        if default_data_collection_rule_id and not isinstance(default_data_collection_rule_id, str):
            raise TypeError("Expected argument 'default_data_collection_rule_id' to be a str")
        pulumi.set(__self__, "default_data_collection_rule_id", default_data_collection_rule_id)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if location and not isinstance(location, str):
            raise TypeError("Expected argument 'location' to be a str")
        pulumi.set(__self__, "location", location)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if public_network_access_enabled and not isinstance(public_network_access_enabled, bool):
            raise TypeError("Expected argument 'public_network_access_enabled' to be a bool")
        pulumi.set(__self__, "public_network_access_enabled", public_network_access_enabled)
        if query_endpoint and not isinstance(query_endpoint, str):
            raise TypeError("Expected argument 'query_endpoint' to be a str")
        pulumi.set(__self__, "query_endpoint", query_endpoint)
        if resource_group_name and not isinstance(resource_group_name, str):
            raise TypeError("Expected argument 'resource_group_name' to be a str")
        pulumi.set(__self__, "resource_group_name", resource_group_name)
        if tags and not isinstance(tags, dict):
            raise TypeError("Expected argument 'tags' to be a dict")
        pulumi.set(__self__, "tags", tags)

    @property
    @pulumi.getter(name="defaultDataCollectionEndpointId")
    def default_data_collection_endpoint_id(self) -> str:
        """
        The ID of the managed default Data Collection Endpoint created with the Azure Monitor Workspace.
        """
        return pulumi.get(self, "default_data_collection_endpoint_id")

    @property
    @pulumi.getter(name="defaultDataCollectionRuleId")
    def default_data_collection_rule_id(self) -> str:
        """
        The ID of the managed default Data Collection Rule created with the Azure Monitor Workspace.
        """
        return pulumi.get(self, "default_data_collection_rule_id")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def location(self) -> str:
        """
        The Azure Region where the Workspace is located.
        """
        return pulumi.get(self, "location")

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="publicNetworkAccessEnabled")
    def public_network_access_enabled(self) -> bool:
        """
        Whether network access from public internet to the Workspace are allowed.
        """
        return pulumi.get(self, "public_network_access_enabled")

    @property
    @pulumi.getter(name="queryEndpoint")
    def query_endpoint(self) -> str:
        """
        The query endpoint for the Azure Monitor Workspace.
        """
        return pulumi.get(self, "query_endpoint")

    @property
    @pulumi.getter(name="resourceGroupName")
    def resource_group_name(self) -> str:
        return pulumi.get(self, "resource_group_name")

    @property
    @pulumi.getter
    def tags(self) -> Mapping[str, str]:
        """
        A mapping of tags that are assigned to the Workspace.
        """
        return pulumi.get(self, "tags")


class AwaitableGetWorkspaceResult(GetWorkspaceResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetWorkspaceResult(
            default_data_collection_endpoint_id=self.default_data_collection_endpoint_id,
            default_data_collection_rule_id=self.default_data_collection_rule_id,
            id=self.id,
            location=self.location,
            name=self.name,
            public_network_access_enabled=self.public_network_access_enabled,
            query_endpoint=self.query_endpoint,
            resource_group_name=self.resource_group_name,
            tags=self.tags)


def get_workspace(name: Optional[str] = None,
                  resource_group_name: Optional[str] = None,
                  opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetWorkspaceResult:
    """
    Use this data source to access information about an existing Workspace.

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_azure as azure

    example = azure.monitoring.get_workspace(name="example-workspace",
        resource_group_name=example_azurerm_resource_group["name"])
    pulumi.export("queryEndpoint", example.query_endpoint)
    ```
    <!--End PulumiCodeChooser -->


    :param str name: Specifies the name of the Workspace.
    :param str resource_group_name: Specifies the name of the resource group the Workspace is located in.
    """
    __args__ = dict()
    __args__['name'] = name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure:monitoring/getWorkspace:getWorkspace', __args__, opts=opts, typ=GetWorkspaceResult).value

    return AwaitableGetWorkspaceResult(
        default_data_collection_endpoint_id=pulumi.get(__ret__, 'default_data_collection_endpoint_id'),
        default_data_collection_rule_id=pulumi.get(__ret__, 'default_data_collection_rule_id'),
        id=pulumi.get(__ret__, 'id'),
        location=pulumi.get(__ret__, 'location'),
        name=pulumi.get(__ret__, 'name'),
        public_network_access_enabled=pulumi.get(__ret__, 'public_network_access_enabled'),
        query_endpoint=pulumi.get(__ret__, 'query_endpoint'),
        resource_group_name=pulumi.get(__ret__, 'resource_group_name'),
        tags=pulumi.get(__ret__, 'tags'))


@_utilities.lift_output_func(get_workspace)
def get_workspace_output(name: Optional[pulumi.Input[str]] = None,
                         resource_group_name: Optional[pulumi.Input[str]] = None,
                         opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetWorkspaceResult]:
    """
    Use this data source to access information about an existing Workspace.

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_azure as azure

    example = azure.monitoring.get_workspace(name="example-workspace",
        resource_group_name=example_azurerm_resource_group["name"])
    pulumi.export("queryEndpoint", example.query_endpoint)
    ```
    <!--End PulumiCodeChooser -->


    :param str name: Specifies the name of the Workspace.
    :param str resource_group_name: Specifies the name of the resource group the Workspace is located in.
    """
    ...
