# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = [
    'GetCertificateResult',
    'AwaitableGetCertificateResult',
    'get_certificate',
    'get_certificate_output',
]

@pulumi.output_type
class GetCertificateResult:
    """
    A collection of values returned by getCertificate.
    """
    def __init__(__self__, certificate_virtual_path=None, id=None, key_vault_secret_id=None, key_virtual_path=None, name=None, nginx_deployment_id=None):
        if certificate_virtual_path and not isinstance(certificate_virtual_path, str):
            raise TypeError("Expected argument 'certificate_virtual_path' to be a str")
        pulumi.set(__self__, "certificate_virtual_path", certificate_virtual_path)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if key_vault_secret_id and not isinstance(key_vault_secret_id, str):
            raise TypeError("Expected argument 'key_vault_secret_id' to be a str")
        pulumi.set(__self__, "key_vault_secret_id", key_vault_secret_id)
        if key_virtual_path and not isinstance(key_virtual_path, str):
            raise TypeError("Expected argument 'key_virtual_path' to be a str")
        pulumi.set(__self__, "key_virtual_path", key_virtual_path)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if nginx_deployment_id and not isinstance(nginx_deployment_id, str):
            raise TypeError("Expected argument 'nginx_deployment_id' to be a str")
        pulumi.set(__self__, "nginx_deployment_id", nginx_deployment_id)

    @property
    @pulumi.getter(name="certificateVirtualPath")
    def certificate_virtual_path(self) -> str:
        """
        The path to the certificate file of this certificate.
        """
        return pulumi.get(self, "certificate_virtual_path")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="keyVaultSecretId")
    def key_vault_secret_id(self) -> str:
        """
        The ID of the Key Vault Secret for this certificate.
        """
        return pulumi.get(self, "key_vault_secret_id")

    @property
    @pulumi.getter(name="keyVirtualPath")
    def key_virtual_path(self) -> str:
        """
        The path to the key file of this certificate.
        """
        return pulumi.get(self, "key_virtual_path")

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="nginxDeploymentId")
    def nginx_deployment_id(self) -> str:
        return pulumi.get(self, "nginx_deployment_id")


class AwaitableGetCertificateResult(GetCertificateResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetCertificateResult(
            certificate_virtual_path=self.certificate_virtual_path,
            id=self.id,
            key_vault_secret_id=self.key_vault_secret_id,
            key_virtual_path=self.key_virtual_path,
            name=self.name,
            nginx_deployment_id=self.nginx_deployment_id)


def get_certificate(name: Optional[str] = None,
                    nginx_deployment_id: Optional[str] = None,
                    opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetCertificateResult:
    """
    Use this data source to access information about an existing Nginx Certificate.

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_azure as azure

    example = azure.nginx.get_certificate(name="existing",
        nginx_deployment_id=example_azurerm_nginx_deployment["id"])
    pulumi.export("id", example.id)
    ```
    <!--End PulumiCodeChooser -->


    :param str name: The name of this Nginx Certificate.
    :param str nginx_deployment_id: The ID of the Nginx Deployment that this certificate is associated with.
    """
    __args__ = dict()
    __args__['name'] = name
    __args__['nginxDeploymentId'] = nginx_deployment_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure:nginx/getCertificate:getCertificate', __args__, opts=opts, typ=GetCertificateResult).value

    return AwaitableGetCertificateResult(
        certificate_virtual_path=pulumi.get(__ret__, 'certificate_virtual_path'),
        id=pulumi.get(__ret__, 'id'),
        key_vault_secret_id=pulumi.get(__ret__, 'key_vault_secret_id'),
        key_virtual_path=pulumi.get(__ret__, 'key_virtual_path'),
        name=pulumi.get(__ret__, 'name'),
        nginx_deployment_id=pulumi.get(__ret__, 'nginx_deployment_id'))


@_utilities.lift_output_func(get_certificate)
def get_certificate_output(name: Optional[pulumi.Input[str]] = None,
                           nginx_deployment_id: Optional[pulumi.Input[str]] = None,
                           opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetCertificateResult]:
    """
    Use this data source to access information about an existing Nginx Certificate.

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_azure as azure

    example = azure.nginx.get_certificate(name="existing",
        nginx_deployment_id=example_azurerm_nginx_deployment["id"])
    pulumi.export("id", example.id)
    ```
    <!--End PulumiCodeChooser -->


    :param str name: The name of this Nginx Certificate.
    :param str nginx_deployment_id: The ID of the Nginx Deployment that this certificate is associated with.
    """
    ...
